<template>
  <div class="app-container">
    <el-form style="background-color: #fff; padding: 15px 5px; border-radius:10px;"  :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <p class="bgtan" style="margin-top: 0;">搜索条件</p>
	 <el-form-item label="套餐名称" prop="packageName">
	   <el-input v-model="queryParams.packageName" placeholder="请输入套餐名称" clearable @keyup.enter="handleQuery" />
	 </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8" style=" border-top-left-radius: 12px; border-top-right-radius: 12px; background-color: #fff;margin: 0;margin-top: 20px;padding: 10px 5px; ">
      <p class="bgtan" style="margin-top: 0;">课程信息</p>
	  <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="[ 'system:tenantPackage:add']"
        >新增</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['formal:class:edit']"
        >修改</el-button>
      </el-col> -->
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:tenantPackage:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['system:tenantPackage:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
     <div style="background-color: #fff; padding: 0 10px;  padding-bottom: 40px; border-bottom-left-radius: 12px; border-bottom-right-radius: 12px;">
		<el-table border :max-height="tableMaxHeight" v-loading="loading" :data="tenantPackageList" @selection-change="handleSelectionChange">
		  <el-table-column type="selection" width="55" align="center" />
		  <!-- <el-table-column label="ID" align="center" prop="id" /> -->
		 <el-table-column label="租户套餐id" align="center" prop="packageId" v-if="false" />
		 <el-table-column label="套餐名称" align="center" prop="packageName" />
		  <el-table-column label="备注" align="center" prop="remark" />
		  <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
		    <template slot-scope="scope">
		      <el-button
		        size="mini"
		        type="text"
		        icon="el-icon-edit"
		        @click="handleUpdate(scope.row)"
		        v-hasPermi="[ 'system:tenantPackage:edit']"
		      >修改</el-button>
		      <el-button
		        size="mini"
		        type="text"
		        icon="el-icon-delete"
		        @click="handleDelete(scope.row)"
		        v-hasPermi="['system:tenantPackage:remove']"
		      >删除</el-button>
		    </template>
		  </el-table-column>
		</el-table>
		
		<pagination
		  v-show="total>0"
		  :total="total"
		  :page.sync="queryParams.pageNum"
		  :limit.sync="queryParams.pageSize"
		  @pagination="getList"
		/> 
	 </div>
    

    <!-- 添加或修改注册-老师-班级（学科）对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <!-- <el-form-item label="老师id" prop="teacherId">
          <el-input v-model="form.teacherId" placeholder="请输入老师id" />
        </el-form-item> -->
		<el-row>
			<el-col :span="24">
				  <el-form-item label="套餐名称" prop="packageName">
				    <el-input v-model="form.packageName" placeholder="请输入套餐名称" />
				  </el-form-item>
				  </el-form-item>
			</el-col>
			
			<el-col :span="24">
				  <el-form-item label="关联菜单">
				    <el-checkbox v-model="menuExpand" @change="handleCheckedTreeExpand($event, 'menu')">展开/折叠</el-checkbox>
				    <el-checkbox v-model="menuNodeAll" @change="handleCheckedTreeNodeAll($event, 'menu')">全选/全不选 </el-checkbox>
				    <el-checkbox v-model="form.menuCheckStrictly" @change="handleCheckedTreeConnect($event, 'menu')">父子联动 </el-checkbox>
				    <el-tree
				      class="tree-border"
				      :data="menuOptions"
				      show-checkbox
				      ref="menuTreeRef"
				      node-key="id"
				      :check-strictly="!form.menuCheckStrictly"
				      empty-text="加载中，请稍候"
				      :props="{ label: 'label', children: 'children' }"
				    ></el-tree>
				  </el-form-item>
			</el-col>

			<el-col :span="24">
				<el-form-item label="备注" prop="remark">
				  <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
				</el-form-item>
			</el-col>
		</el-row>
        <!-- <el-form-item label="班级id" prop="classId">
          <el-input v-model="form.classId" placeholder="请输入班级id" />
        </el-form-item> -->

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listTenantPackage,
  getTenantPackage,
  delTenantPackage,
  addTenantPackage,
  updateTenantPackage,
  changePackageStatus
} from "@/api/zhihuixy/tenantPackage";
import { treeselect as menuTreeselect, tenantPackageMenuTreeselect } from "@/api/system/menu";
export default {
  name: "Class",
  dicts: ['sys_subject'],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 注册-老师-班级（学科）表格数据
      tenantPackageList: [],
	  openDataScope: false,
	  menuExpand: false,
	  menuNodeAll: false,
	  deptExpand: true,
	  deptNodeAll: false,
	  // 菜单列表
	  menuOptions: [],
	  // 部门列表
	  deptOptions: [],
      // 弹出层标题
      title: "",
	  tableMaxHeight:400,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        packageName: ""
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        packageId: [{ required: true, message: "租户套餐id不能为空", trigger: "blur" }],
        packageName: [{ required: true, message: "套餐名称不能为空", trigger: "blur" }]
      },
	  deptOptions:[],
	  kiuesegh:[],
	  kiueseghs:[],
	  fku:false
	  
    };
  },
  created() {
	  window.onresize = () => {
	            this.changeTableMaxHeight()
	          }
	          this.changeTableMaxHeight()
    this.getList();
	// this.getdept(0)
  },
  mounted() {
  	window.onresize = () => {
  	          this.changeTableMaxHeight()
  	        }
  	        this.changeTableMaxHeight()
  },
  methods: {
	  
	  getdept(val){
	  		  let kuesf=  {'parentId':val}
	  		  // this.kiuesegh = []
			  console.log(kuesf)
	  		listDepts(kuesf).then(response => {
	  		  this.deptOptions = this.handleTree(response.data, "deptId");
	  		  this.deptOptions.filter(rou =>{
	  			  if(rou.children != undefined){
	  			  	rou.children.filter(rour =>{
	  			  					  this.kiuesegh.push(rour)
	  			  	})		  
	  			  }
	  			  // this.kiuesegh = rou.children
	  			  // this.kiuesegh.push(rou.children)
	  			  console.log(rou.children)
	  		  })
	  		  this.kiueseghs = this.kiuesegh
	  		  // this.deptOptions = response.data
	  		  console.log(this.kiuesegh)
	  		});  
	  },
	  getdeptfr(val){
	  		  let kuesf=  {'parentId':val}
	  		  // this.kiuesegh = []
	  			  console.log(kuesf)
	  		this.kiuesegh = []
	  		listDeptode(kuesf).then(response => {
	  		  this.kiuesegh = this.handleTree(response.data, "deptId");
	  		  console.log(this.kiuesegh)
	  		});  
	  },
    /** 查询注册-老师-班级（学科）列表 */
    getList() {
      this.loading = true;
      listTenantPackage(this.queryParams).then(response => {
        this.tenantPackageList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
     if (this.$refs.menu != undefined) {
       this.$refs.menu.setCheckedKeys([]);
     }
     this.menuExpand = false,
     this.menuNodeAll = false,
     this.deptExpand = true,
     this.deptNodeAll = false,
     this.form = {
       roleId: undefined,
       roleName: undefined,
       roleKey: undefined,
       roleSort: 0,
       status: "0",
       menuIds: [],
       deptIds: [],
       menuCheckStrictly: true,
       deptCheckStrictly: true,
       remark: undefined
     };
     this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.packageId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
	  this.getMenuTreeselect();
      this.open = true;
      this.title = "添加租户套餐";
	  this.form.schoolId =  this.$store.state.user.schoolId
	  this.fku = false
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
	 const roleId = row.packageId || this.ids
	 const roleMenu = this.getPackageMenuTreeselect(roleId);
	 getTenantPackage(roleId).then(response => {
	   this.form = response.data;
	   this.open = true;
	   this.$nextTick(() => {
	     roleMenu.then(res => {
			 console.log(res)
	       let checkedKeys = res.data.checkedKeys
	       checkedKeys.forEach((v) => {
	           this.$nextTick(()=>{
	               this.$refs.menuTreeRef.setChecked(v, true ,false);
	           })
	       })
	     });
	   });
	   this.title = "修改角色";
	 });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.packageId!= undefined) {
            this.form.menuIds = this.getMenuAllCheckedKeys();
            updateTenantPackage(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            this.form.menuIds = this.getMenuAllCheckedKeys();
            addTenantPackage(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
	/** 修改状态 */
	handleStatusChange(row) {
		let text = row.status === "0" ? "启用" : "停用";
	  const ids = row.packageId || this.ids;
	  // delClass(ids).then(response => {
	  // 		this.getList();
	  // 		this.$modal.msgSuccess("删除成功");
	  // });
	  this.$modal.confirm("确认要\"" + text + "\"\"" + row.packageName + "\"套餐吗？").then(function() {
	    return changePackageStatus(row.packageId, row.status);
	  }).then(() => {
	    this.getList();
	    this.$modal.msgSuccess("操作成功");
	  }).catch(() => {});
	},
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
	  // delClass(ids).then(response => {
	  // 		this.getList();
	  // 		this.$modal.msgSuccess("删除成功");
	  // });
      this.$modal.confirm('是否确认删除"' + ids + '"的数据项？').then(function() {
        return delTenantPackage(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/tenantPackage/export', {
        ...this.queryParams
      }, `class_${new Date().getTime()}.xlsx`)
    },
	mjyhess(val){
		this.form.className = val.deptName
	},
	mjyhes(val){
		console.log(val,this.form.schoolName)
		this.form.schoolName = val.deptName
		this.kiuesegh = []
		let kuesf= {'parentId':val.deptId} 
		listDeptode(kuesf).then(response => {
		  this.kiuesegh = this.handleTree(response.data, "deptId");
		  console.log(this.kiuesegh)
		});  
		// this.getdept(val.deptId)
	},
	/** 查询菜单树结构 */
	getMenuTreeselect() {
	  menuTreeselect().then(response => {
	    this.menuOptions = response.data;
	  });
	},
	// 所有菜单节点数据
	getMenuAllCheckedKeys() {
	  // 目前被选中的菜单节点
	  let checkedKeys = this.$refs.menuTreeRef.getCheckedKeys();
	  // 半选中的菜单节点
	  let halfCheckedKeys = this.$refs.menuTreeRef.getHalfCheckedKeys();
	  checkedKeys.unshift.apply(checkedKeys, halfCheckedKeys);
	  return checkedKeys;
	},
	/** 根据角色ID查询菜单树结构 */
	getPackageMenuTreeselect(packageId) {
	  return tenantPackageMenuTreeselect(packageId).then(response => {
	    this.menuOptions = response.data.menus;
	    return response;
	  });
	},
	// 所有部门节点数据
	getDeptAllCheckedKeys() {
	  // 目前被选中的部门节点
	  let checkedKeys = this.$refs.dept.getCheckedKeys();
	  // 半选中的部门节点
	  let halfCheckedKeys = this.$refs.dept.getHalfCheckedKeys();
	  checkedKeys.unshift.apply(checkedKeys, halfCheckedKeys);
	  return checkedKeys;
	},
	// 树权限（展开/折叠）
	handleCheckedTreeExpand(value, type) {
	  if (type == 'menu') {
	    let treeList = this.menuOptions;
	    for (let i = 0; i < treeList.length; i++) {
	      this.$refs.menu.store.nodesMap[treeList[i].id].expanded = value;
	    }
	  } else if (type == 'dept') {
	    let treeList = this.deptOptions;
	    for (let i = 0; i < treeList.length; i++) {
	      this.$refs.dept.store.nodesMap[treeList[i].id].expanded = value;
	    }
	  }
	},
	// 树权限（全选/全不选）
	handleCheckedTreeNodeAll(value, type) {
	  if (type == 'menu') {
	    this.$refs.menu.setCheckedNodes(value ? this.menuOptions: []);
	  } else if (type == 'dept') {
	    this.$refs.dept.setCheckedNodes(value ? this.deptOptions: []);
	  }
	},
	// 树权限（父子联动）
	handleCheckedTreeConnect(value, type) {
	  if (type == 'menu') {
	    this.form.menuCheckStrictly = value ? true: false;
	  } else if (type == 'dept') {
	    this.form.deptCheckStrictly = value ? true: false;
	  }
	},
	// 获取屏幕高度
	showFilterForm () {
	      this.filterActive = !this.filterActive
	      this.changeTableMaxHeight()
	    },
	
	    changeTableMaxHeight () {
	      let height = document.body.offsetHeight // 网页可视区域高度
	      // if (this.filterActive) {
	      //   this.tableMaxHeight = height - 320
	      // } else {
	        this.tableMaxHeight = height - 250
	      // }
	      console.log(height)
	    }
	
  }
};
</script>

<style scoped lang="scss">
	.bgtan{
		border-left: 3px solid #4775EA;
		padding-left: 10px;
	}
	
	.app-container{
		background-color: #f6f6f6;
		// height: 100vh;
	}
</style>
